# This is a multi-stage Dockerfile (build and run)

# stage 1
# stage name is "hugobuilder" and will be referenced later
FROM alpine:3.15 AS hugobuilder

# The versions
ENV HUGO_VERSION 0.89.4
ENV GLIBC_VERSION 2.33-r0

# Install glibc (https://github.com/sgerrand/alpine-pkg-glibc)
# glibc is needed for Hugo extended, because it is dynamically linked
RUN set -x && \
  apk add --update wget ca-certificates libstdc++ && \
  wget -q -O /etc/apk/keys/sgerrand.rsa.pub https://alpine-pkgs.sgerrand.com/sgerrand.rsa.pub && \
  wget https://github.com/sgerrand/alpine-pkg-glibc/releases/download/$GLIBC_VERSION/glibc-$GLIBC_VERSION.apk && \
  apk --no-cache add glibc-$GLIBC_VERSION.apk && \
  wget https://github.com/sgerrand/alpine-pkg-glibc/releases/download/$GLIBC_VERSION/glibc-bin-$GLIBC_VERSION.apk && \
  wget https://github.com/sgerrand/alpine-pkg-glibc/releases/download/$GLIBC_VERSION/glibc-i18n-$GLIBC_VERSION.apk && \
  apk --no-cache add glibc-bin-$GLIBC_VERSION.apk glibc-i18n-$GLIBC_VERSION.apk && \
  /usr/glibc-compat/bin/localedef -i en_US -f UTF-8 en_US.UTF-8

# Install Hugo (extended version, glibc required!)
RUN wget -q -O /tmp/hugo.tar.gz https://github.com/gohugoio/hugo/releases/download/v${HUGO_VERSION}/hugo_extended_${HUGO_VERSION}_Linux-64bit.tar.gz && \
  tar -zxvf /tmp/hugo.tar.gz -C /tmp/ && \
  mv /tmp/hugo /usr/bin/hugo && \
  rm -rf /tmp/hugo*
RUN hugo version

# Alternatively, install Hugo (glibc not required, you can comment out the glibc installation code block)
#RUN wget -q -O /tmp/hugo.tar.gz https://github.com/gohugoio/hugo/releases/download/v${HUGO_VERSION}/hugo_${HUGO_VERSION}_Linux-64bit.tar.gz && \
#  tar -zxvf /tmp/hugo.tar.gz -C /tmp/ && \
#  mv /tmp/hugo /usr/bin/hugo && \
#  rm -rf /tmp/hugo*
#RUN hugo version

# Clean-up
RUN apk del wget ca-certificates && \
  rm /var/cache/apk/*

# The source files are copied from "./hugo" subdir in our GitLab repo to "/site" within the container
COPY ./hugo/ /site
WORKDIR /site

# And then we just run Hugo
RUN /usr/bin/hugo --minify


# stage 2
#FROM nginx:1.15-alpine
FROM nginx:alpine


WORKDIR /usr/share/nginx/html/

# Clean the default public folder
RUN rm -fr * .??*

# Finally, the "public" folder generated by Hugo in the previous stage ("hugobuilder") is copied into the public fold of nginx
COPY --from=hugobuilder /site/public /usr/share/nginx/html